<?php
/**
* @package Alexandria Book Library 1.0.1 for Joomla
* @copyright Copyright (C) 2006-2009 Henk von Pickartz. All rights reserved.
* GNU/GPL license
*/

// no direct access
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die();
jimport( 'joomla.html.html' );
jimport('joomla.plugin.plugin');
include_once(JPATH_SITE.DS.'components'.DS.'com_abook'.DS.'helpers'.DS.'route.php');
class plgContentLoadbook extends JPlugin {
	public function __construct(& $subject, $config)
        {
                parent::__construct($subject, $config);
                $this->loadLanguage();
		//print_r(JFactory::getLanguage());
        }
	public function onContentPrepare( $context, &$article, &$params, $page = 0 ) {
		if (strpos($article->text, 'loadbook') === false) {
                        return true;
                }
		// get a style sheet
		$doc = JFactory::getDocument();
		$doc->addStyleSheet( 'components/com_abook/assets/css/style.css' );
	
	 	$regex = '/{(loadbook)\s*(.*?)}/i';
		$componentParams = JComponentHelper::getParams( 'com_abook' );
		if ($componentParams->get('linkimage')!=''){
			$img='<img src="components/com_abook/images/link/'.$componentParams->get( 'linkimage', 'carrello.png').'" alt="" hspace="5px" style="vertical-align:middle;"/>';
		}
		$parms=array();
		$matches = array();
		preg_match_all( $regex, $article->text, $matches, PREG_SET_ORDER );
		if ($matches) {
		foreach ($matches as $elm) {
			$line=str_replace("&nbsp;", " ", $elm[2]);
			$line=str_replace(" ", "&", $line);
			parse_str( $line, $parms );
			$html=$this->_book($parms, $params, $img);
			$article->text = preg_replace($regex, $html, $article->text, 1);
		}
		}
	}

	protected function _book($parms, $params, $img) {
	//printf("<pre>%s</pre>", print_r($plgParams,1));
		$id=$parms['id'];
		$db	= JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*, CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(":", b.id, b.alias) ELSE b.id END as slug');
		$query->from('#__abbook AS b');
		if ($this->params->get('showeditor')){
			$query->select('e.name AS editor, e.id');
			$query->join('left', '#__abeditor AS e ON e.id=b.ideditor');
		}
		if ($this->params->get('showlocation')){
			$query->select('l.name AS location, l.id');
                        $query->join('left', '#__ablocations AS l ON l.id=b.idlocation');
		}
		if ($this->params->get('showlibrary')){
                        $query->select('lb.name AS library, lb.id');
                        $query->join('left', '#__ablibrary AS lb ON lb.id=b.idlibrary');
                }
		$query->where('b.id='.$id);
		$db->setQuery( $query );
		$book = $db->loadObject();
		if (!$book) {
			$html  ="<div class='abook_alert'>";
			$html .= JText::sprintf("PLG_LOADBOOK_BOOK_NOT_FOUND", $id);
			$html .="</div>";
			return $html;
		}
		$user           = JFactory::getUser();
		$groups = $user->authorisedLevels();
		if (!in_array($book->access, $groups)) {
		//if ($book->access>(int) $user->gid){
                        return;
		}
		if ($book->published=='0') {
			$html  ="<div class='abook_alert'>";
			$html .= JText::_("PLG_LOADBOOK_BOOK_NOT_PUBLISHED")." ". $id;
			$html .="</div>";
			return $html;
		}else{
			$query = $db->getQuery(true);
			$query->select('*, CASE WHEN CHAR_LENGTH(alias) THEN CONCAT_WS(":", id, alias) ELSE id END as slug');
			$query->from('#__abcategories');
			$query->where('id='.$book->catid);
			$query->where('published=1');
			$db->setQuery( $query );
			$db->query();
			$row=$db->getNumRows();

			if ($this->params->get('showcategory')&&($row==1)) {
                		$category = $db->loadObject();
				if (!in_array($category->access, $groups)){
                 		       return;
                		}
			}else{
				$html  ="<div class='abook_alert'>";
                        	$html .= JText::_("PLG_LOADBOOK_CATEGORY_NOT_PUBLISHED")." ".$book->catid;
                        	$html .="</div>";
				return $html;
			}
		}
		if ($this->params->get('showrating')){
			$query = $db->getQuery(true);
                        $query->select('ROUND( rating_sum / rating_count ) AS rating, rating_count');
                        $query->from('#__abrating');
                        $query->where('book_id='.$id);
			$db->setQuery( $query );
                        $rating = $db->loadObject();
			$rating->rating = intval(@$rating->rating);
                        $rating->rating_count = intval(@$rating->rating_count);
		}
		if ($this->params->get('showauthor')){
			$query = $db->getQuery(true);
                        $query->select('*, CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug');
                        $query->from('#__abbookauth AS ab');
			$query->join('INNER', '#__abauthor a ON ab.idauth = a.id');
                        $query->where('ab.idbook='.$id);
                	$db->setQuery( $query );
                	$authors = $db->loadObjectList();
			$n=count($authors);
			if ($n==0){
				$authors="";
			}
		}
		$itemid=$this->params->get('set_itemid');
		$link=JRoute::_( AbookHelperRoute::getBookRoute($book->slug, $category->slug));
		$html= null;
		$parms['style']= !isset($parms['style'])? 'standard':$parms['style'];
		switch ($parms['style']){
			case 'bibliography':
				$style="";
				$style.='<span class="bibliography">&#149; ';
				if ($authors!=""){
                               		$auth=null;
                               		$k=1;
					foreach ($authors as $author){
                                               	$link=JRoute::_( AbookHelperRoute::getAuthorRoute($author->slug));
	                                        $auth.='<a href="'.$link.'" class="biblio_author">'.$author->name."</a>";
        	                                $auth.= ($n == $k) ? '': ', ';
                	                        $k=$k+1;
					}
					$style.=$auth;
				}
				$style.=', <a href="'.$link.'" class="biblio_title">'.$book->title;
				if ($book->subtitle!=""){
					$style.='. '.$book->subtitle;
				}
				$style.='</a>';
				if ($book->location!=""){
					$style.=', '.$book->location;
				}
				if ($book->editor!=""){
					$style.=', '.$book->editor;
				}
				if ($book->year!=0){
					$style.=', '.$book->year;
				}
				$style.='</span>';
			break;
			case "standard":
			default:
		if (($parms['style']=="standard")|| (!$parms['style'])){
		$style="";
		if ($this->params->get('showtitle')) $style.="\n".'<h2><a href="'.$link.'">'.$book->title."<br /><small><small>".$book->subtitle."</small></small></a></h2>";
		$style.='<div class="booktab">';
		$style.='<div class="cover" height="112px" width="100px">';
		if ($book->image!=''){
			$componentParams = JComponentHelper::getParams( 'com_abook' );
			$style.='<img src="'.$book->image.'" width="80" hspace="5" vspace="5" alt="'.$book->title.'" />';
		}else{
			$style.='<img src="components/com_abook/assets/images/nocover.png" alt="nocover" width="80" />';
		}
		$style.="</div>";
		$style.='<div class="bookdetails">';
		if ($this->params->get('showrating')){
			$star="";
                        $imgstar = '';

                        // look for images in template if available
			$starImageOn = JHTML::_('image','system/rating_star.png', NULL, NULL, true);
	                $starImageOff = JHTML::_('image','system/rating_star_blank.png', NULL, NULL, true);

                        for ($i=0; $i < $rating->rating; $i++) {
                	        $imgstar .= $starImageOn;
                        }
                        for ($i=$rating->rating; $i < 5; $i++) {
                        	$imgstar .= $starImageOff;
                        }
                        $star .= '<span class="content_rating">';
                        $star .= $imgstar .'&nbsp;/&nbsp;';
                        $star .= intval( $rating->rating_count );
                        $star .= "</span>\n";
		}
		$rate=$star;
		if ($this->params->get('showrating')){
			 $style .= "\n".'<div><label>'.JText::_('PLG_LOADBOOK_VOTE_USER_RATING').":</label> ".$rate."</div>";
		}
		if ($this->params->get('showcategory')){
			$link=JRoute::_( AbookHelperRoute::getCategoryRoute($category->slug));
			$style .= "\n".'<div>';
			$style .= "\n".'<label>'.JText::_('PLG_LOADBOOK_CATEGORY').":</label> ";
			$style .= "\n".'<a href="'.$link.'">'.$category->title.'</a>';
			$style .= "\n</div>";
		}
		if ($authors!=""){
			if ($this->params->get('showauthor')){
				$auth=null;
                                $k=1;   
                                foreach ($authors as $author){
                                	$link=JRoute::_( AbookHelperRoute::getAuthorRoute($author->slug));
                                        $auth.='<a href="'.$link.'">'.$author->name."</a>";
                                        $auth.= ($n == $k) ? '': ', ';
                                        $k=$k+1;
                                 }
				 $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_AUTHOR').":</label> ".$auth."</div>";
			}
		}
		if ($this->params->get('showeditor')){
			if ($book->editor!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_EDITOR').":</label> ".$book->editor."</div>";
		}
		if ($this->params->get('showpage')){
			if ($book->pag!=0) $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_PRICE').":</label> ".$book->pag."</div>";
		}
		if ($this->params->get('showprice')){
			if ($book->price!=0) $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_PRICE').":</label> ".$book->price."</div>";
		}
		if ($this->params->get('showisbn')){
			if ($book->isbn!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_ISBN').":</label> ".$book->isbn."</div>";
		}
		if ($this->params->get('showcatalog')){
			if ($book->catalogo!=0) $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_CATALOG').":</label> ".$book->catalogo."</div>";
		}
		if ($this->params->get('showlibrary')){
			if ($book->library!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_LIBRARY').":</label> ".$book->library."</div>";
		}
		if ($this->params->get('showlocation')){
			if ($book->location!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_LOCATION').":</label> ".$book->location."</div>";
		}
		if ($this->params->get('showyear')){
                	if ($book->year!=0) $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_YEAR').":</label> ".$book->year."</div>";
                }
		if ($this->params->get('showlink')){
			if ($book->url!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_LINK').':</label> <a href="'.$book->url.'">'.$img.$book->url_label.'</a></div>';
		}
		if ($this->params->get('showfile')){
                	if ($book->file!="") $style.="\n".'<div><label>'.JText::_('PLG_LOADBOOK_FILE').':</label> <a href="'.$book->file.'">'.$book->file.'</a></div>';
                }
		$style.="</div>";
		$style.="</div>";
		}
			break;
		}
		$html .= $style;
		$html .= '<div class="clr"></div>';
	
		return $html;
	}

}

?>
